#/***************************************************************************
# *   Copyright (C) 2008 by Paul Hardwick                                   *
# *   paul@peck.org.uk                                                      *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
# ***************************************************************************/
"All the application UI code resides here or is launched from here"
 
_rev = "$Revision: 18 $"[10:-1].strip()
__version__ = "1.2."+_rev
__author__ = "Paul Hardwick <paul@peck.org.uk>"
__date__ =  "$Date: 2009-05-26 23:27:06 +0100 (Tue, 26 May 2009) $"[6:18].strip()
 
import pygtk
pygtk.require('2.0')
import gtk
import gobject
import sys,  os
import ConfigParser
import PINdialog
import RadioDialog
import RadioDialog3column
import connectioneditor
import ProfileDialog
import Preferences
import hsocversion
from xml.sax.saxutils import escape
tooltips = gtk.Tooltips()

about_text = '''

A connection manager for Option's 3.5G data devices.
Version %s %s Copyright Paul Hardwick 2004-2009

WWW.PHARSCAPE.ORG

'''%(hsocversion.BuildVersion, __date__)

license='''
HSOconnect is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the Licence, or (at your option) any later version.

HSOconnect is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied 
warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with HSOconnect; if not, write to the 
Free Software Foundation, Inc.,
59 Temple Place, Suite 330, 
Boston, MA  02111-1307
USA
'''
#translators
credits="""
A BIG Thank You to the following forum members
Vesa, Micha, Bob, Dezso, Franz, Jnethack, Gunnar,
Picazamora
"""
confdir = ''
imgdir = ''
guiconf = "HSOconnect.gui.cfg"
conf = "HSOconnect.cfg"
interface = "org.pharscape.HSOconnect.Interface"
service = "org.pharscape.HSOconnect.Service" #"com.example.SampleService"
import dbus
import dbus.service
import dbus.mainloop.glib

class HSOconnectException(dbus.DBusException):
    _dbus_error_name = 'org.pharscape.HSOconnectException'

class HSOGUI(dbus.service.Object):

    "The GUI class"
    
    ##########################################
    #dbus Service Interface   
    @dbus.service.method(interface, in_signature='', out_signature='')
    def Hide(self, ):
        "Hide HSOconnect GUI"
        self.window.hide()
        return 

    @dbus.service.method(interface, in_signature='', out_signature='')
    def Show(self,):
        "Show HSOconnectGUI"
        self.window.show()
        return 
        
    @dbus.service.method(interface, in_signature='', out_signature='s')
    def Connect(self,):
        "Connect to Internet"
        if self.connectDisabled == True:
            return "Waiting"
        
        return str(self.justconnect())

    @dbus.service.method(interface, in_signature='', out_signature='s')
    def Disconnect(self,):
        "Disconnect from Internet"
        
        return str(self.justdisconnect())
        
    @dbus.service.method(interface, in_signature='', out_signature='as')
    def ReportStats(self,):
        """Report Status:
        Device Ready
        Operator Name
        Technology
        Signal Strength
        Registration State
        Connected State
        RX data
        TX data
        Total data
        """
        return [str( not self.connectDisabled), self.operator_value, self.tech_value, str(self.signal_value),
                self.registration_value, str(self.connectedState), 
                self.mrx, self.mtx,  self.mrt ]
                
#    @dbus.service.method(interface, in_signature='', out_signature='')
#    def RaiseException(self):
#        raise HSOconnectException('The RaiseException method does what you might '
#                            'expect')
#
#    @dbus.service.method(interface, in_signature='', out_signature='(ss)')                            
#    def GetTuple(self):
#        return ("Hello Tuple", " from example-service.py")
#
#    @dbus.service.method(interface, in_signature='', out_signature='a{ss}')
#    def GetDict(self):
#        return {"first": "Hello Dict", "second": " from HSOconnect.py"}

    @dbus.service.method(interface, in_signature='', out_signature='')
    def Exit(self):
        "Terminate HSOconnect"
        self.doTerminate(True)
        return
        
    ###########################
    #do nothing place holders -
    # get overloaded
    def justconnect(self):
        "Redirected"
        return None
        
    def justdisconnect(self):
        "Redirected"
        return None
        
       
    def copyProfile(self, prf):
        "Redirected"
        return None
    def saveconnection(self, connection):
        "Redirected"
        return None
    def savepreference(self, preference):
        "Redirected"
        return None       
    def updateConfig(self, dic = {}):
        "Redirected"
        return None
        
    def deleteProfile(self, profile):
        "Redirected"
        return None        
        
    def doCommand(self,cmd):
        "Redirected"
        return None        
    def currentMode(self):  
        "Redirected"
        return None
 
    def resetTransfer(self):
        "Redirected"
        return None
        
    def terminate(self):
        "Redirected"
        return None

    def setMode(self, mode):
        "Redirected"
        return None
        
    def checkConnect(self):
        "Redirected"
        return -1, -1

    def scanNetworks(self):
        "Redirected"
        return None
    
    def setNetwork(self, network):
        "Redirected"
        pass
    
    def autoNetwork(self):
        "Redirected"
        return None
    
    def getInfo(self):
        "Redirected"
        return None
        
    def secondaryLED(self):
        "Redirected"
        return None
   
    ########################## 

    def __init__(self, conn, object_path):
        dbus.service.Object.__init__(self, conn, object_path)
        
    def prep(self, confdr, imagedr, strings, prog, langdir, term): 
        "Class initialisation and build main window"
        global confdir, imgdir
        self.minimised = False #is application minimised
        self.callquit = False #flag set by HSOconsole that triggers UI to close down app.
        self.mrx = "0"  #Initial data transfer values
        self.mtx = "0"
        self.mrt = "0"
        self.operator_value = "" 
        self.tech_value = ""
        self.signal_value =""
        self.registration_value = ""
        self.connectedState = False
        self.confdir = confdr #Configuration directory
        imgdir = imagedr #Location of graphics
        self.prog = prog #program configuration dictionary
        self.but = {} #button dictionary to hold graphical object references
        self.subprocs = {} #dictionary of sub-process being run  by applications
        self.str = strings # The language strings
        self.scanning = False #is the device scanning for networks
        self.toggle = True #toggle the display while scanning
        self.langdir = langdir #location of languages
        self.terminate = term #method of HSOconsole to terminate application
        #hack code to count languages and profiles - if more than one then show menu item
        thelist = os.listdir(self.langdir)
        profiles = []
        for n in thelist:
            if os.path.isdir(os.sep.join([self.langdir, n])):
                profiles.append(n)
        if len(profiles)>1: self.languagemenu = True #show language menu item
        else: self.languagemenu = False #or not
        thelist = os.listdir(self.confdir)
        profiles = []
        for n in thelist:
            if os.path.isdir(os.sep.join([self.confdir, n])):
                profiles.append(n)
        if len(profiles)>1: self.connectionmenu = True #show profile menu item
        else: self.connectionmenu = False
####################################################################
        # Create our application window
####################################################################
        self.dbgwin = None #reference to debug window
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.guiconfig() #now load the configuration
        self.window.set_title(self.str['title'])
        self.window.set_resizable(False)
        
        self.window.set_position(gtk.WIN_POS_CENTER)
        if self.but['Window'].has_key('bgcolour1'): self.window.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.but['Window']['bgcolour1']))

        self.window.connect("delete_event", self.quit)
        self.window.connect("window-state-event", self.window_event)
        self.window.set_border_width(2)
        if self.but['Window'].has_key('icon'): 
            self.window.set_icon_from_file(os.sep.join([imgdir, self.but['Window']['icon']]))

        
#################################
        # Configuration Menu
#################################
        maint_menu = gtk.Menu()    # Don't need to show menus

        # Create the menu items
        self.mode_item = gtk.MenuItem(self.str['menu_mode_select'])
        self.autonet_item = gtk.MenuItem(self.str['menu_autonet'])
        self.network_item = gtk.MenuItem(self.str['menu_net'])

        self.language_item = gtk.MenuItem(self.str['menu_language'])
        self.prefs_item = gtk.MenuItem(self.str['menu_prefs'])
        self.resettf_item = gtk.MenuItem(self.str['menu_reset_transfer'])
        quit_item = gtk.MenuItem(self.str['menu_quit'],True)

        # Add them to the menu
        maint_menu.append(self.mode_item)
        maint_menu.append(self.autonet_item)
        maint_menu.append(self.network_item)       
        maint_menu.append(self.language_item)
        maint_menu.append(self.prefs_item)
        maint_menu.append(self.resettf_item)
        maint_menu.append(quit_item)

        # Attach the callback functions to the activate signal
        self.mode_item.connect_object("activate", self.menuitem_response, "mode")
        self.autonet_item.connect_object("activate", self.menuitem_response, "autonet")
        self.network_item.connect_object("activate", self.menuitem_response, "network")

        self.language_item.connect_object("activate", self.menuitem_response, "language")
        self.prefs_item.connect_object("activate", self.menuitem_response, "prefs")
        self.resettf_item.connect_object("activate", self.menuitem_response, "reset")
        quit_item.connect_object ("activate", self.menuitem_response, "quit")



        if self.languagemenu: self.language_item.show()
        self.prefs_item.show()
        self.resettf_item.show()
        quit_item.show()

        #maint_menu.show()
        
        root_menu = gtk.MenuItem(self.str['menu1_title'])
        root_menu.show()
        root_menu.set_submenu(maint_menu)
 #################################
        # Profile Menu
#################################       
        profile_menu = gtk.Menu()
        self.connection_item = gtk.MenuItem(self.str['menu_connection'],True)
        self.connectioneditor_item = gtk.MenuItem(self.str['menu_connectioneditor'])
        self.profilecopy_item = gtk.MenuItem(self.str['menu_profilecopy'])      
  
        profile_menu.append(self.connection_item)
        profile_menu.append(self.connectioneditor_item)
        profile_menu.append(self.profilecopy_item)
        
        self.connection_item.connect_object("activate", self.menuitem_response, "connection")
        self.connectioneditor_item.connect_object("activate", self.menuitem_response, "connectioneditor")
        self.profilecopy_item.connect_object("activate", self.menuitem_response, "profilecopy")  
        if self.connectionmenu: self.connection_item.show()
        self.connectioneditor_item.show()
        self.profilecopy_item.show()
        root2_menu = gtk.MenuItem(self.str['menu2_title'])
        root2_menu.show()
        root2_menu.set_submenu(profile_menu)       
#################################
        # Help Menu
#################################
        help_menu = gtk.Menu()    # Don't need to show menus
        help_item = gtk.MenuItem(self.str['menu_help'])
        log_item = gtk.MenuItem(self.str['menu_log'])
        about_item = gtk.MenuItem(self.str['menu_about'])

        help_menu.append(help_item)
        help_menu.append(log_item)
        help_menu.append(about_item)

        help_item.connect_object("activate", self.menuitem_response, "help")
        log_item.connect_object("activate", self.menuitem_response, "log")
        about_item.connect_object("activate", self.menuitem_response, "about")
        
        help_item.show()
        log_item.show()
        about_item.show()

        rooth_menu = gtk.MenuItem(self.str['menuh_title'])
        rooth_menu.show()
        rooth_menu.set_submenu(help_menu)

###############################################
    # Add menu to menu bar and menubar to window
        box1 = gtk.VBox(False, 0)
        self.window.add(box1)
        box1.show()
        
        menu_bar = gtk.MenuBar()
        box1.pack_start(menu_bar, False, False, 1)
        menu_bar.show()
        menu_bar.append (root_menu)
        menu_bar.append (root2_menu)
        menu_bar.append (rooth_menu)
        rooth_menu.set_right_justified(True)
#############################################################
        #Top box with logo buttons  etc
        box2 = gtk.HBox(False, 0)
        image = gtk.Image()
        if self.but['Window'].has_key('logo'): 
            image.set_from_file(os.sep.join([imgdir, self.but['Window']['logo']]))
        image.show()
        box2.pack_start(image, False, False , 0)
        
        but = "Button0" #Connect button
        if self.but[but]['visible']:
            if self.but[but]['imageobj']:
                self.but[but]["button"] = gtk.Button()
            else:
                self.but[but]["button"] = gtk.ToggleButton()
            tooltips.set_tip(self.but[but]["button"], self.but[but]['text'])
            if self.but[but]['imageobj']:
                self.but[but]["button"].set_image(self.but[but]['imageobj'])
            else:
                self.but[but]["button"].set_label(self.but[but]['text'])
            self.but[but]["button"].set_size_request(int(self.but[but]['width']), int(self.but[but]['height']))
            box2.pack_start(self.but[but]["button"], False, False, 0)
            if self.but[but].has_key('bgcolour'): self.but[but]["button"].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.but[but]['bgcolour']))
            self.but[but]["button"].connect("clicked", self.connect_callback)
            if self.but[but]['imageobj']: self.but[but]["button"].set_relief(gtk.RELIEF_NONE)
            self.but[but]["button"].show()
        
        buts = self.but.keys()
        buts.sort()
        #buts.reverse()
        for but in buts: #Show as many buttons as are defined and marked visible in configuration file
            if but in ["Window", "Button0", "ButtonDefault","QuickButton1","QuickButton2","QuickButton3",]: continue
            if self.but[but]['visible']  == 1:
                self.subprocs[but]=0 #init sub process for buttons
                self.but[but]["button"] = gtk.Button()
                tooltips.set_tip(self.but[but]["button"], self.but[but]['text'])
                self.but[but]["button"].set_size_request(int(self.but[but]['width']), int(self.but[but]['height']))
                if self.but[but].get('imageobj',None):
                    self.but[but]["button"].add(self.but[but]['imageobj'])
                else:
                    self.but[but]["button"].set_label(self.but[but]['text'])
                box2.pack_start(self.but[but]["button"], False, False, 0)
                if self.but[but].has_key('bgcolour'): self.but[but]["button"].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.but[but]['bgcolour']))
                if self.but[but]['imageobj']:
                    self.but[but]["button"].set_relief(gtk.RELIEF_NONE)
                command = eval("lambda a1 :self.execute('%s', self.but['%s']['app'])"%(but, but), {'self':self})
                self.but[but]["button"].connect("clicked", command)
                self.but[but]["button"].show()
        #Quick buttons
        if self.prog.get('show_quick_switch_buttons','0') == '1':
            vbox = gtk.VBox(False,0)
            for b in "123":
                but = "QuickButton"+b
                if self.but[but].get('visible','0')== 1:
                    self.but[but]["button"] = gtk.Button()
                    tooltips.set_tip(self.but[but]["button"],  self.but[but].get('text',but))
                    self.but[but]["button"].set_size_request(int(self.but[but].get('width',20)), int(self.but[but].get('height',50)))
                    if self.but[but].get('imageobj',None):
                        self.but[but]["button"].add(self.but[but]['imageobj'])
                    else:
                        self.but[but]["button"].set_label(self.but[but]['text'])
                    vbox.pack_start(self.but[but]["button"], False, False, 0)
                    if self.but[but].has_key('bgcolour'): self.but[but]["button"].modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse(self.but[but]['bgcolour']))
                    if self.but[but].get('imageobj',None):self.but[but]["button"].set_relief(gtk.RELIEF_NONE)
                    command = eval("lambda a1 :self.quickcommand('%s', self.but['%s'].get('command','AT'))"%(but, but), {'self':self})
                    self.but[but]["button"].connect("clicked", command)
                    self.but[but]["button"].show()
            vbox.show()
            box2.pack_end(vbox, False, False, 0)
        
        #signal strength indicator 
        self.hbox3 = gtk.Image()
        self.hbox3.set_from_file(self.sigimg[0])
        self.hbox3.show()
        box2.pack_end(self.hbox3, False, False, 0)
        self.bounce = False
        
        #############################################################
        # Create the status fields for operator name, registration and technology
        box3 = gtk.VBox(False, 0)
        box3.set_size_request(int(self.but["Window"]['width']), int(self.but["Window"]['height']))
        self.status3 = gtk.Label()
        self.status3.set_markup('<span size = "%s" color="%s"><b>%s</b></span>'%(self.but['Window']['statsize'], self.but['Window']['fgcolour1'], self.str['operator_start_name']))
        box3.pack_start(self.status3, False, False, 0)
        self.status3.show()
        
        self.status4 = gtk.Label()
        self.status4.set_markup('<span size = "%s" color="%s">%s</span>'%(self.but['Window']['statsize'], self.but['Window']['fgcolour2'], self.str['reg02']))
        box3.pack_start(self.status4, False, False, 0)
        self.status4.show()
        
        self.status5 = gtk.Label()
        self.status5.set_markup('<span size = "%s" color="%s">%s</span>'%(self.but['Window']['statsize'], self.but['Window']['fgcolour3'], self.str['code1']))
        box3.pack_start(self.status5, False, False, 0)
        self.status5.show()
    
        # Pack box3 in to box2 into box1
        box2.pack_end(box3, False, False, 5)
        box3.show()
        box1.pack_start(box2, False, False, 0)
        
        box2.show()
        ###########################################################
        #Status bar showing data volume transferred
        frame = gtk.Frame(label=None) 
        box1.pack_start(frame, False, False, 0)
        frame.show() #put a fram
       
        box4 = gtk.HBox(False, 0) #To hold the tx/rx labels etc

        self.dataTxStat1 = gtk.Label()
        self.dataTxStat1.set_markup('<span size = "%s" color="%s"><b>%s</b></span>'%(self.but['Window']['statsize'], self.but['Window']['txcolour1'], self.str['tx']))
        self.dataTxStat1.show()
        box4.pack_start(self.dataTxStat1, False, False, 0)
        self.dataTxStat = gtk.Label()
        self.dataTxStat.set_markup('<span size = "%s" color="%s">%s</span>'%(self.but['Window']['statsize'], self.but['Window']['txcolour2'], '-'))
        self.dataTxStat.set_width_chars(7)
        
        self.dataTxStat.show()
        box4.pack_start(self.dataTxStat, False, False, 0)
        
        self.dataRxStat1 = gtk.Label()
        self.dataRxStat1.set_markup('<span size = "%s"  color="%s"><b>%s</b></span>'%(self.but['Window']['statsize'], self.but['Window']['rxcolour1'], self.str['rx']))
        self.dataRxStat1.show()
        box4.pack_start(self.dataRxStat1, False, False, 0)      
        self.dataRxStat = gtk.Label()
        self.dataRxStat.set_markup('<span size = "%s"  color="%s">%s</span>'%(self.but['Window']['statsize'], self.but['Window']['rxcolour2'], '-'))
        self.dataRxStat.set_width_chars(7)
        self.dataRxStat.show()
        box4.pack_start(self.dataRxStat, False, False, 0)

        
        self.dataRtStat = gtk.Label()
        self.dataRtStat.set_markup('<span size = "%s"  color="%s">%s</span>'%(self.but['Window']['statsize'], self.but['Window']['rxcolour2'], '-'))
        self.dataRtStat.set_width_chars(7)
        self.dataRtStat.show()
        box4.pack_end(self.dataRtStat, False, False, 0)
        self.dataRtStat1 = gtk.Label()
        self.dataRtStat1.set_markup('<span size = "%s"  color="%s"><b>%s</b></span>'%(self.but['Window']['statsize'], self.but['Window']['rxcolour1'], self.str['rt']))
        self.dataRtStat1.show()
        box4.pack_end(self.dataRtStat1, False, False, 0)   
        
        box4.show()
        box1.pack_start(box4, False, False, 0)
        
        #set ghosted items
        self.dataRxStat.set_sensitive(False)
        self.dataTxStat.set_sensitive(False)       
        self.but["Button0"]["button"].set_sensitive(False)
        self.but["Button0"]["button"].grab_focus()
        self.connectDisabled = True #set flag for dbus client to indicate connecting not allowed yet
        if len(sys.argv) > 1 and ('HIDE' in sys.argv[1:] ):
            self.window.hide()
        else:
            self.window.show()
        #Hide menu items until device detected
        self.hidemenu()

        if self.prog['debug']=='1':
            self.textview = gtk.TextView()
            self.showdebugwin()


    def guiconfig(self):  
        "load gui configuration file and images"
### Load '.default' gui conf first
        self.guicfg = ConfigParser.ConfigParser()
        conf = os.sep.join([self.confdir, 'default', guiconf])
        if not os.path.isfile(conf):
            print "Configuration file [%s] not found!"%conf
            sys.exit(1)
        try:
            self.guicfg.read(conf)
        except ConfigParser.ParsingError , n:
            print n
            sys.exit(1)
        butdefault = {}
        for option in self.guicfg.options("ButtonDefault"):
            butdefault[option]=self.guicfg.get("ButtonDefault", option)
        #butdefault contains .default default!
        self.but['Window'] = {}    
        for option in self.guicfg.options('Window'):
            self.but['Window'][option]=self.guicfg.get('Window', option)
        #self.but['Window'] contains .default default
        for section in self.guicfg.sections():
            if section == "Window": continue
            self.but[section] = butdefault.copy() #fill each button with defaults
            for option in self.guicfg.options(section):
                 self.but[section][option]=self.guicfg.get(section, option)
### Now get actual configuration
        self.guicfg = ConfigParser.ConfigParser()
        conf = os.sep.join([self.confdir, self.prog['profile'], guiconf])
        if not os.path.isfile(conf):
            print "Configuration file [%s] not found!"%conf
            sys.exit(1)
        try:
            self.guicfg.read(conf)
        except ConfigParser.ParsingError , n:
            print n
            sys.exit(1)
        for option in self.guicfg.options("ButtonDefault"):
            butdefault[option]=self.guicfg.get("ButtonDefault", option) #update default with actula profile defaults
        #load Window configuration
        for option in self.guicfg.options('Window'):
            self.but['Window'][option]=self.guicfg.get('Window', option) #update window section with window settings
        for section in self.but:#guicfg.sections():
            if section == "Window": continue
            self.but[section]['imageobj']= None
            self.but[section]['altimageobj']= None   
            try:
                for option in self.guicfg.options(section):
                    try:
                        self.but[section][option] =self.guicfg.get(section, option)
                    except:
                        pass
            except:
                pass
            for intkey in ['visible', 'height','width']:
                try:
                    self.but[section][intkey]=int(self.but[section][intkey])
                except:
                    self.WarningDialog(self.str['error'], self.str['error_config_int']%(section, intkey))
            if os.path.isfile(os.sep.join([imgdir, self.but[section]['image']])):
                imgfile = os.sep.join([imgdir, self.but[section]['image']])
            elif os.path.isfile(self.but[section]['image']):
                imgfile = self.but[section]['image']
            else: imgfile = None
            if os.path.isfile(os.sep.join([imgdir, self.but[section]['altimage']])):
                altimgfile = os.sep.join([imgdir, self.but[section]['altimage']])
            elif os.path.isfile(self.but[section]['altimage']):
                altimgfile = self.but[section]['altimage']
            else: altimgfile = None
            
            if imgfile:
                try:
                    image = gtk.Image()
                    image.set_from_file(imgfile)
                    image.show()
                    self.but[section]['imageobj'] = image
                    if altimgfile:
                        image = gtk.Image()
                        image.set_from_file(altimgfile)
                        image.show()                        
                        self.but[section]['altimageobj'] = image
                    else:
                        self.but[section]['altimageobj'] = None
                except:
                    pass
                    self.ErrorDialog(self.str['error'], self.str['error_config_image']%(section, self.but[section]['image']))
            else:
                self.but[section]['imageobj']= None
                self.but[section]['altimageobj']= None
                #self.WarningDialog(self.str['error'], self.str['error_config_noimage']%(section, self.but[section]['image']))
        self.loadSignal()
    
    def loadSignal(self):   
        "load signal strength images"
        self.sigimg = [0, 1, 2, 3, 4, 5]
        self.sigimg[5]= os.sep.join([imgdir, self.but['Window'].get('signal','signal'), "5.gif"])
        self.sigimg[4]= os.sep.join([imgdir,  self.but['Window'].get('signal','signal'), "4.gif"])
        self.sigimg[3]= os.sep.join([imgdir,  self.but['Window'].get('signal','signal'), "3.gif"])
        self.sigimg[2]= os.sep.join([imgdir, self.but['Window'].get('signal','signal'), "2.gif"])
        self.sigimg[1]= os.sep.join([imgdir, self.but['Window'].get('signal','signal'), "1.gif"])
        self.sigimg[0]= os.sep.join([imgdir, self.but['Window'].get('signal','signal'), "0.gif"])




    ###########################
    #Window event handlers
    def quit(self, a=None, b=None, c=None): 
        "routine called by all to tidy up and quit app"
        if self.callback: gobject.source_remove(self.callback)
        self.terminate() #call HSOconsole teminating routine
        if self.dbgwin:
            self.dbgwin.destroy()
        self.window.destroy()
        gtk.main_quit()
        print "Quit gtk.main"
        return True
 
    def doTerminate(self, flag): 
        "called by HSOconsole to set quit flag"
        self.callquit = flag 
    
    def window_event(self, widget, event, data=None):   
        "Routine to change /track window state - used for window titles"
        if event.changed_mask & gtk.gdk.WINDOW_STATE_ICONIFIED:
            if event.new_window_state & gtk.gdk.WINDOW_STATE_ICONIFIED:
                self.minimised = True
                self.updateTitle()
            else:
                self.minimised = False
                self.updateTitle()

    ########################## 
    ###########################
    #Routines to load dialogs
    def ErrorDialog(self, title, msg):  
        "display an error"
        msgbox = gtk.MessageDialog(parent = self.window, buttons = gtk.BUTTONS_OK, flags = gtk.DIALOG_MODAL, 
                                    type= gtk.MESSAGE_ERROR, message_format = msg)
        msgbox.set_title(title)
        msgbox.run()
        msgbox.destroy()

        
    def WarningDialog(self, title, msg):  
        "display a warning"
        msgbox = gtk.MessageDialog(parent = self.window, buttons = gtk.BUTTONS_OK, flags = gtk.DIALOG_MODAL, 
                                    type= gtk.MESSAGE_WARNING, message_format = msg)
        msgbox.set_title(title)
        msgbox.run()
        msgbox.destroy()
        
    def getpin(self, title, prompt):  
        "returns pin code"
        return PINdialog.runPIN(self.window, title, prompt, self.str)
        
    def showconnectioneditor(self):  
        "allows user to edit connection"
        return connectioneditor.runEditorDialog(self.window, self.prog, self.str)

    def getMode(self):  
        "3G mode dialog"
        mdlg = RadioDialog.RadioDialog(self.window, self.str["umts_mode_dialog_title"], 
                                     (self.str['umts_mode_0'], 
                                        self.str['umts_mode_1'], 
                                        self.str['umts_mode_2'], 
                                        self.str['umts_mode_3']), 
                                    self.currentMode())
        ans = mdlg.run()[1]
        if ans == None: return
        self.setMode(ans)
        
    def doPrefs(self):
       return Preferences.runPrefDialog(self.window, self.prog, self.str)    
        
    def showProfiles(self, profiles, current=-1): 
        "show list of profiles"
        ndlg = RadioDialog.RadioDialog(self.window, self.str["profile_dialog_title"], 
                                     profiles, 
                                    current, 1)
        return ndlg.run() #SEL|DEL,index|None if user cancels else index of op list
        
    def showLanguages(self, profiles, current=-1): 
        "Show list of languages"
        ndlg = RadioDialog.RadioDialog(self.window, self.str["languages_dialog_title"], 
                                     profiles, 
                                    current, width = 250)
        return ndlg.run() #None if user cancels else index of op list
          

    def showNetworks(self, ops, current): 
        "show network list"
        if not self.scanning : return #Throw away list if auto got selected during scan
        #Displsy list of operators and return user selection
        self.scanning = False
        self.toggle = True
        ndlg = RadioDialog3column.RadioDialog3column(self.window, self.str["network_dialog_title"], 
                                     ops, 
                                    current)
        ans = ndlg.run() #None if user cancels else index of op list
        if ans:
            self.setNetwork(ops[ans][3])# ops[ans][3] == operator code

    def antennaState(self, state):
        #devices such as GE441/2 with antenna status switch- allow for auto-connect
        if state:
            #connect
            self.connect_callback()
        else:
            #disconnect
            self.justdisconnect()
            
    def doProfileEntry(self):
        "show Copy profile dialog"
        profile = ProfileDialog.runProfile(self.window, self.str['copy_profile_title'], self.str['copy_profile_enter'], self.str)
        if profile:
            self.copyProfile(profile)
        
    def which(self,appstr):
        "parse comma seperated string to find first app the exists"
        apps = appstr.split(',')
        for a in apps:
            sts = os.system("which "+a.strip())
            if sts == 0:
                return a
        
    def doHelp(self):   
        "load system default browser with help text"
        uri = os.sep.join([self.langdir, self.prog['language'], 'help.html'])
        browser =  self.which(self.prog['browser'])
        if  os.path.isfile(uri):
            gobject.spawn_async([ browser, uri],  standard_output=True, standard_error=True, flags=gobject.SPAWN_SEARCH_PATH)
        else:
            uri = os.sep.join([self.langdir,'default', 'help.html'])
            gobject.spawn_async([ browser , uri],  standard_output=True, standard_error=True, flags=gobject.SPAWN_SEARCH_PATH)
            
    def doLog(self):   
        "load viewer with log file"
        uri = self.prog['logfile']
        viewer = self.which(self.prog['logviewer'])
        gobject.spawn_async([ viewer, uri],  standard_output=True, standard_error=True, flags=gobject.SPAWN_SEARCH_PATH)
    
    def doAbout(self):  
        "An About dialog"
        try:
            dlg = gtk.AboutDialog()
            dlg.set_version("\n%s %s "%(hsocversion.BuildVersion, __date__))
            dlg.set_name("HSOconnect")
            dlg.set_program_name("HSOconnect")
            copy = "Copyright 2004-2009 Paul Hardwick \npaul@peck.org.uk\n"
            ans = self.getInfo()
            if ans:
                copy=copy+str(ans[4])
            dlg.set_copyright(copy)
            dlg.set_website("www.pharscape.org")
            dlg.set_translator_credits(credits)
            dlg.set_license(license)
            #dlg.set_logo()
        except:
            rep_text = about_text
            ans = self.getInfo()
            if ans:
                rep_text =rep_text + str(ans[4])+"\n"
            rep_text = rep_text+license
               
                
            dlg = gtk.MessageDialog(self.window, buttons=gtk.BUTTONS_OK, 
                                    type=gtk.MESSAGE_INFO, message_format = rep_text)
            dlg.set_title(self.str['about_title']+" "+self.str['title'])
        dlg.run()
        dlg.destroy()


    ########################## 
    ###########################
    #Routines called by main program to update widgets
        

    def tech(self, value):
        "update the 2g/3g technology widget"
        self.tech_value = value
        self.status5.set_markup('<span size = "%s" color="%s">%s</span>'%(self.but['Window']['statsize'], self.but['Window']['fgcolour3'], escape(value)))

    def registration(self, valuestr, value):   
        "update the registration status widget"
        self.registration_value = valuestr
        self.registration_value_int = value
        self.status4.set_markup('<span size = "%s" color="%s">%s</span>'%(self.but['Window']['statsize'], self.but['Window']['fgcolour2'], escape(valuestr)))

    def operator(self, value):  
        "update the operator name widget"
        self.operator_value = value
        self.status3.set_markup('<span size = "%s" color="%s"><b>%s</b></span>'%(self.but['Window']['statsize'], self.but['Window']['fgcolour1'], escape(value)))
        
    def doSignal(self, strength): 
        "update widget to show change in signal strength"
        self.signal_value = strength #for remote dbus monitoring
        if self.bounce: return
        self.bounce = True
        if strength == 0: norm = 0
        else: norm = int(strength/32.0*5)+1
        self.hbox3.clear()
        self.hbox3.set_from_file(self.sigimg[norm])
        self.bounce = False

    def connect(self, callback=None):  
        "Setup link between GUI button and callback handler in HSOconsole"
        if callback:
            self.connect_cbk = callback

    def allowconnect(self, flag):    
        "called by registration status routine to enable widgets only when registered"
        if flag:
            self.enableconnect()
        else:
            self.disableconnect()

    def disableconnect(self):   
        "disable connect button"
        self.but["Button0"]["button"].set_sensitive(False)
        self.connectDisabled = True

    def enableconnect(self):    
        "enable connect button"
        self.but["Button0"]["button"].set_sensitive(True)
        self.connectDisabled = False

    def connect_callback(self, data=None):    
        "Routine called by connect button click event"
        self.disableconnect()
        self.debug("Clicked Connect")
        if self.connectedState == True: #we are disconnecting
            self.prog['autoreconnect']='0' #user chose to disconnect so auto reconnect not wanted.
        self.connect_cbk()

    def updateTitle(self):   
        "provide summary of conection when minimised in window title"
        if self.minimised:
            title = "%s R:%s T:%s"%(self.str['title_small'], self.mrx, self.mtx)
            self.window.set_title(title)
        else:
            self.window.set_title(self.str['title'])
        
    def showRxData(self, txt):  
        "write rx data to widget"
        self.dataRxStat.set_markup('<span size = "%s" color="%s">%s</span>'%(self.but['Window']['statsize'], self.but['Window']['rxcolour2'], txt))
        self.mrx = txt
        
    def showRunningTotal(self, txt):  
        "write rt data to widget"
        self.dataRtStat.set_markup('<span size = "%s" color="%s">%s</span>'%(self.but['Window']['statsize'], self.but['Window']['rxcolour2'], txt))
        self.mrt = txt
        
    def showTxData(self, txt):  
        "write tx data to widget"
        self.dataTxStat.set_markup('<span size = "%s" color="%s">%s</span>'%(self.but['Window']['statsize'], self.but['Window']['txcolour2'], txt))        
        self.mtx = txt
        
    def showmenu(self): 
        "display optional menu items"
        self.mode_item.show()
        self.autonet_item.show()        
        self.network_item.show()
        

    def hidemenu(self): 
        "hide optional menu items"
        self.mode_item.hide()
        self.autonet_item.hide()        
        self.network_item.hide()
        
    def showconnected(self): 
        "called by main program to change button state dusring connection"
        self.hidemenu()
        self.dataRxStat.set_sensitive(True)
        self.dataTxStat.set_sensitive(True)              
        self.enableconnect()
        tooltips.set_tip(self.but["Button0"]["button"], self.but["Button0"]['alttext'])
        if (not int(self.prog['dont_swap_images'])) and self.but["Button0"]['altimageobj']: self.but["Button0"]["button"].set_image(self.but["Button0"]['altimageobj'])
        elif (not self.but["Button0"]['imageobj']):
            self.but["Button0"]["button"].set_label(self.but["Button0"]["alttext"])
        self.connectedState = True
        
    def showdisconnected(self):  
        "called by main program to change button state when disconnecting"
        self.enableconnect()
        self.showmenu()
        self.dataRxStat.set_sensitive(False)
        self.dataTxStat.set_sensitive(False)        
        tooltips.set_tip(self.but["Button0"]["button"], self.but["Button0"]['text'])
        if (not int(self.prog['dont_swap_images'])) and self.but["Button0"]['imageobj']: self.but["Button0"]["button"].set_image(self.but["Button0"]['imageobj'])
        elif (not self.but["Button0"]['imageobj']):
            self.but["Button0"]["button"].set_label(self.but["Button0"]["text"])
        self.connectedState = False
        if int(self.prog['autoreconnect']) : 
            gobject.timeout_add(int(self.prog['autoconnectdelay'])*1000, self.autoconnect) 
        
    def autoconnect(self):
        print "attempting auto connect..."
        if self.connectedState == False:
            if self.registration_value_int in [1, 5] : 
                self.connect_callback()
                return False #prevent it being called again until disconnected state is reset
            else: 
                return True

        
        
    def menuitem_response(self, widget): 
        "what to do when menu item selected"
        if widget == "quit":
            self.quit(None, None, None)
        elif widget == "reset":
            self.resetTransfer()
            return        
        elif widget == "mode":
            self.getMode()
            return
        elif widget == "help":
            self.doHelp()
            return
        elif widget == "prefs":
            ans = self.doPrefs()
            if ans != None:
                self.updateConfig(ans)
            return            
        elif widget == "log":
            self.doLog()
            return
        elif widget == "about":
            self.doAbout()
            return
        elif widget == "network":
            self.scanning = True
            self.registration(self.str['reg02'])
            self.scanNetworks()
            return
        elif widget == "profilecopy":
            self.doProfileEntry()
            return
        elif widget == "autonet":
            self.scanning = False
            self.autoNetwork()            
            return
        elif widget == "connection":
            thelist = os.listdir(self.confdir)
            profiles = []
            for n in thelist:
                if os.path.isdir(os.sep.join([self.confdir, n])):
                    profiles.append(n)
            if ".svn" in profiles: profiles.remove('.svn')
            if "default" in profiles: profiles[profiles.index("default")]=self.str['default_profile']
            for n in range(len(profiles)):
                profiles[n] = profiles[n].replace('_', ' ')                
            profiles.sort()
            current = -1
            tprof = self.prog['profile'].replace("_", " ")
            for n in range(len(profiles)):
                if profiles[n] == tprof : #index of matching profile to current profile
                    current = n
                    break
            ans = self.showProfiles(profiles, current)
            if ans[0]==None: return
            if ans[0]=="DEL":
                if profiles[ans[1]] == self.str['default_profile']: return #don't delete default
                elif ans[1]==current:
                    self.updateConfig({'profile': "default"})
                self.deleteProfile(profiles[ans[1]].replace(" ", "_"))
                return
            if ans[0]=="SEL":
                if profiles[ans[1]] == self.str['default_profile']: profiles[ans[1]] = "default"
                self.updateConfig({'profile': profiles[ans[1]].replace(" ", "_")})
            return
        elif widget == "connectioneditor":
            ans = self.showconnectioneditor()
            if ans != None:
                self.saveconnection(ans)
            return
        elif widget == "language":
            names = {}
            nm = [y.split(':') for y in open(os.sep.join([self.langdir, 'languages.cfg']), 'r').readlines()] 
            nm = [  (a[0].strip() , a[1].strip()) for a in nm ]
            names.update(nm)
            thelist = os.listdir(self.langdir)
            languages = []
            for n in thelist:
                lpath = os.sep.join([self.langdir, n])
                if os.path.isdir(lpath):
                    languages.append(n)
            if ".svn" in languages: languages.remove('.svn')
            if "default" in languages: languages[languages.index("default")]=self.str['default_language']
            for n in range(len(languages)):
                languages[n] =  names.get(languages[n],languages[n]) #languages[n].replace('_', ' ')                
            languages.sort()
            current = -1
            tprof = self.prog['language']
            for n in range(len(languages)):
                if languages[n] == tprof : #index of matching profile to current profile
                    current = n
                    break
            ans = self.showLanguages(languages, current)
            if ans[0] != None:
                if ans[0]=='DEL':
                    pass
                if ans[0]=='SEL':
                    #handle select item
                    if languages[ans[1]] == self.str['default_language']:
                       self.updateConfig({'language': 'default'})
                    else:
                        for n in names:
                            if names[n] ==  languages[ans[1]]:
                                self.updateConfig({'language': n})
                                break
            return

    
    def childprocterminated(self, pid, condition, button):
        "Called if Child process finishes"
        print "called terminated child process"
        self.but[button]["button"].set_sensitive(True)
        self.subprocs[button] = 0
        
    def execute(self, but, app):  
        "Execute application associated with secondary buttons"
        if True:#not self.subprocs[but]:
            try:
                self.subprocs[but] = gobject.spawn_async([ app, ],  standard_output=False, standard_error=False, flags=gobject.SPAWN_SEARCH_PATH)
                #gobject.child_watch_add(self.subprocs[but][0] , self.childprocterminated, data=but, priority=gobject.PRIORITY_HIGH)
                #self.but[but]["button"].set_sensitive(False)
            except:
                self.WarningDialog(self.str['warning'], self.str['warning_application_failed']+app)
        
    def quickcommand(self, but, app):  
        "Execute commands associated with quick buttons"
        self.doCommand(app)

    def periodicInitPhase(self):  
        "called during device detect and port open phase"
        global hsolinkstatus
        if hsolinkstatus:
            hsolinkstatus = False
            self.ErrorDialog("hsolinkcontrol", "Missing or incorrectly installed.\n NO Internet control!!!\n")
        res = self.app_callback()
        if res != "runfirst":
            self.callback = gobject.idle_add( self.periodic)
            if int(self.prog["autoconnect"]):
                gobject.timeout_add(int(self.prog['autoconnectdelay'])*1000, self.autoconnect) 
            return False #stop periodicInitPhase call back
        return True #return the callback state
        
    def periodic(self):  
        global hsolinkstatus
        "called frequently to service the serial device and refresh widgets"
        if hsolinkstatus:
            hsolinkstatus = False
            self.ErrorDialog("hsolinkcontrol", "Missing or incorrectly installed.\n NO Internet control!!!\n")
        if self.scanning:
            #when waiting for serial routine to return with network list - toggle registration state to show we are busy
            if self.toggle:
                self.registration(self.str["reg00"])
                self.toggle=False
            else:
                self.registration(self.str["reg02"])
                self.toggle=True

        res = self.app_callback()
        if res == "running" and self.connectedState == True:
            tx, rx, rt = self.checkConnect()
            self.showTxData(tx)
            self.showRxData(rx)
            self.showRunningTotal(rt)
            if self.minimised:  self.updateTitle()
        if self.callquit:
            self.quit()
        return True #return the callback state
        
    def schedule(self, period, callback):  
        "setup the periodic call back that drives the program"
        
        self.app_callback = callback #from main program
        self.callback = None #the call back routine setup when serial is active - self.periodic
        gobject.timeout_add(3000, self.periodicInitPhase) 
        #self.callback = gobject.idle_add( self.periodic)

        
    def debug(self, txt): 
        "write out debug text"
        if self.prog['debug'] == '1':
            #write text to the debug text area
            self.textbuffer.insert_at_cursor(txt)

    def showdebugwin(self): 
        "Display debug window"
        self.dbgwin = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.dbgwin.set_title("HSOcDbg")
        #self.dbgwin.set_keep_below(True)
        #self.dbgwin.set_position(gtk.WIN_POS_CENTER)
        self.dbgwin.set_default_size(500, 300)

        self.status1 = gtk.Label('------')
        self.dbgwin.vbox = gtk.VBox(False, 0)
        self.dbgwin.add( self.dbgwin.vbox )
        self.dbgwin.vbox.show()
        self.dbgwin.vbox.pack_start(self.status1, False, False, 0)
        self.status1.show()

        self.dbw = gtk.ScrolledWindow()
        self.dbw.set_border_width(10)
        self.dbw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.textview.set_editable(False)
        self.textbuffer = self.textview.get_buffer()
        #self.dbw.add_with_viewport(self.status1)
        self.dbw.add(self.textview)
        self.dbw.show()
        self.textview.show()
        self.debug("The Debug Window\n")
        self.dbgwin.vbox.pack_start(self.dbw, True, True, 10)
        self.dbgwin.show()
        
session_bus = None
BusName = None
guiob = None
def init():
    global session_bus, BusName,  guiobj
    dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
    session_bus = dbus.SessionBus()
    BusName = dbus.service.BusName(service, session_bus)
    #print BusName
    guiobj =  HSOGUI(session_bus, "/hsoc")
    return guiobj

def delete():
    guiobj.remove_from_connection(session_bus, "/hsoc")

    
def run(msgarray = None):
    "Called to start the run loop once HSOGUI instantiated"
    global hsolinkstatus
    hsolinkstatus = True
    if msgarray:
        for n in msgarray:
            if n == "hsolink":
                hsolinkstatus = False
    try:
        print "in ui.run()"
        gtk.main()
        print "end ui.run()"
    except KeyboardInterrupt:
        print "UI External Keyboard Interrupt"
    return         
